
.area _DATA

.area _CODE

.include "defineValues.h.s"
.include "cpct_includes.h.s"
.include "system/ai.h.s"
.include "macros.h.s"
.include "system/animations.h.s"

;;;;;;;;;;;;;;;;;;;;
;; VARIABLES GLOBALES
;;;;;;;;;;;;;;;;;;;;
.globl _spr_vshot
.globl _spr_enemyshot
.globl _spr_tiburon_0
.globl _spr_bubble
.globl _spr_tiburon2_0
.globl _spr_submaca_0

.globl _spr_submarino2_0

.globl _spr_tronco_pompa_0
.globl _spr_hierba_0
.globl _spr_misil
.globl _spr_explosion_0
.globl _spr_hierba_1


;; VARIABLES SPRITE
SPR_MOTHERSHIP_H = 18
SPR_MOTHERSHIP_W = 18 
SPR_PLAYERSHIP_W == 7
SPR_PLAYERSHIP_H == 16 
SPR_ENEMY1_W = 10
SPR_ENEMY1_H == 10
SPR_PLAYERSHOT_W == 4
SPR_PLAYERSHOT_H == 2
SPR_TIBURON_H = 14
SPR_TIBURON_W = 10
SPR_BUBBLE_W = 6
SPR_BUBBLE_H = 12

SPR_MISIL_W = 7
SPR_MISIL_H = 5
;; DIMENSIONES PANTALLAS CARGA
SPR_LOGO_W == 21
SPR_LOGO_H == 36
SPR_LVL_W == 21 
SPR_LVL_H == 28
SPR_PRESS_SPACE_W == 44
SPR_PRESS_SPACE_H == 28
SPR_GAMEOVER_W == 35 
SPR_GAMEOVER_H == 40
SPR_GAMEOVERINSTRUCTIONS_W == 44 
SPR_GAMEOVERINSTRUCTIONS_H == 32
SPR_FONDO_W == 40
SPR_FONDO_H == 32
SPR_TRONCO_W == 10
SPR_TRONCO_H == 50
SPR_HIERBA_W == 40
SPR_HIERBA_H == 3
SPR_CORAL_W  == 9
SPR_CORAL_H  == 30
SPR_SUBMACA_W == 10
SPR_SUBMACA_H == 10

PLAYER_X == 16

;; VARIABLES LANE
LANE_DY == 30 ;; Distancia entre lineas
LANE2_Y == 40
LANE1_Y == (LANE2_Y + LANE_DY)
LANE0_Y == (LANE1_Y + LANE_DY)

_entities::
    .ds ARRAY_SIZE                  ;;reserva 50bytes en la zona a la que apunta la etiqueta

_zero_value_at_the_end::
    .ds 1                   ;; sits in memory right after the entities array, to protect from overflow

_next_free_entity::
    .ds 2                   ;; esta variable ocupa 2B (tamanyo de puntero)

_active_entities::
    .ds 1

;;;;;; POR QUE NEXT_FREE_ENTITY VA SIEMPRE ENTRE PARENTESIS
;;;;;;
;;;;;;      Es un puntero. En la variable hay una direccion de memoria, en la que hay guardado un valor.
;;;;;;      El valor de esa direccion, es OTRA direccion de memoria, que es a la que apunta el puntero.
;;;;;;
;;;;;;      _next_free_entity = &ent1; -> _next_free_entity guarda una direccion de memoria, EN ESA DIRECCION DE MEMORIA, esta la direccion de ent1


;; deberia ser global??
;; va a ser usado por otros ficheros?? -> en principio no


playership::
    .db TYPE_PLAYER
    .db CMP_RENDER | CMP_MOVABLE | CMP_INPUT | CMP_COLLIDER | CMP_ANIMATED | CMP_AI  ;; CMP
    .db PLAYER_X                                ;; X
    .db min_y                                      ;; Y
    .db SPR_PLAYERSHIP_W                        ;; Width
    .db SPR_PLAYERSHIP_H                        ;; Height
    .db 0                                       ;; vx
    .db 0                                       ;; vy
    .dw _spr_submarino2_0                       ;; puntero a sprite
    .dw no_ai
    .db 0                                       ;; ai_counter
    .db 0                                       ;; collides_against
    .db anim_enemy1_time
    .dw animation_submarino
    .dw 0                                       ;; previous video position
    .dw playershot                                       ;; type_shot

CheckSize playership, ENTITY_SIZE

playershot::
    .db TYPE_SHOT
    .db CMP_MOVABLE | CMP_AI | CMP_RENDER  | CMP_COLLIDER      ;; CMP
    .db PLAYER_X + 2                            ;; X
    .db 172                                     ;; Y (PLAYERSHIPY - 8)
    .db SPR_PLAYERSHOT_W                        ;; Width
    .db SPR_PLAYERSHOT_H                        ;; Height
    .db 4                                       ;; vx
    .db 0                                       ;; vy
    .dw _spr_vshot                              ;; puntero a sprite
    .dw sys_ai_behaviour_autodestroy
    .db 14                                      ;; ai_counter
    .db TYPE_ENEMY                              ;; collides_against
    .db 0
    .dw 0
    .dw 0                                       ;; previous video position
    .dw 0

CheckSize playershot, ENTITY_SIZE

enemy2::
    .db TYPE_ENEMY
    .db CMP_RENDER | CMP_MOVABLE | CMP_AI | CMP_COLLIDER | CMP_ANIMATED
    .db 70
    .db LANE2_Y
    .db SPR_TIBURON_W
    .db SPR_TIBURON_H
    .db -1
    .db 0
    .dw _spr_tiburon_0
    .dw sys_ai_behaviour_enemy
    .db counter_enemy_move                                       ;; ai_counter
    .db TYPE_PLAYER                             ;; collides_against
    .db anim_enemy1_time
    .dw animation_tiburon
    .dw 0                                       ;; previous video position
    .dw enemyshot                                       ;; type_shot

tiburonRojoTemplate::
    .db TYPE_ENEMY
    .db CMP_RENDER | CMP_MOVABLE | CMP_AI | CMP_COLLIDER | CMP_ANIMATED
    .db 70
    .db LANE2_Y
    .db SPR_TIBURON_W
    .db SPR_TIBURON_H
    .db -1
    .db 0
    .dw _spr_tiburon2_0
    .dw sys_ai_behaviour_enemy
    .db counter_enemy_move                      ;; ai_counter
    .db TYPE_PLAYER                             ;; collides_against
    .db anim_enemy1_time
    .dw animation_tiburon_rojo
    .dw 0                                       ;; previous video position
    .dw bubbleshot                                       ;; type_shot

CheckSize tiburonRojoTemplate, ENTITY_SIZE

enemyshot::
    .db TYPE_ENEMYSHOT
    .db CMP_MOVABLE | CMP_RENDER  | CMP_COLLIDER      ;; CMP
    .db 0                           ;; X
    .db 172                                     ;; Y (PLAYERSHIPY - 8)
    .db SPR_PLAYERSHOT_W                        ;; Width
    .db SPR_PLAYERSHOT_H                        ;; Height
    .db -1                                       ;; vx
    .db 0                                       ;; vy
    .dw _spr_enemyshot                          ;; puntero a sprite
    .dw sys_ai_behaviour_autodestroy
    .db 60                                  ;; ai_counter
    .db TYPE_PLAYER                              ;; collides_against
    .db 0
    .dw 0
    .dw 0                                       ;; previous video position
    .dw 0

CheckSize enemyshot, ENTITY_SIZE
bubbleshot::
    .db TYPE_ENEMYSHOT
    .db CMP_MOVABLE | CMP_RENDER  | CMP_COLLIDER  | CMP_AI      ;; CMP
    .db 0                                       ;; X
    .db 172                                     ;; Y (PLAYERSHIPY - 8)
    .db SPR_BUBBLE_W                            ;; Width
    .db SPR_BUBBLE_H                            ;; Height
    .db -1                                      ;; vx
    .db -5                                       ;; vy
    .dw _spr_bubble                             ;; puntero a sprite
    .dw sys_ai_zigzag
    .db initial_zigzag_counter                   ;; ai_counter
    .db TYPE_PLAYER                              ;; collides_against
    .db 0
    .dw 0
    .dw 0                                       ;; previous video position
    .dw 0
;;;;;;;;;;;;;;;;;;;;
;; FUNCIONES
;;;;;;;;;;;;;;;;;;;;

CheckSize bubbleshot, ENTITY_SIZE

;tile0::
;    .db TYPE_MOTHERSHIP
;    .db CMP_MOVABLE | CMP_RENDER       ;; CMP
;    .db 64                           ;; X
;    .db 164                                   ;; Y (PLAYERSHIPY - 8)
;    .db 4                        ;; Width
;    .db 8                        ;; Height
;    .db -1                                       ;; vx
;    .db 0                                       ;; vy
;    .dw _tile_00                              ;; puntero a sprite
;    .dw 0
;    .db 0                                ;; ai_counter
;    .db TYPE_PLAYER                              ;; collides_against
;    .db 0
;    .dw 0
;    .dw 0                                       ;; previous video position
;    .dw 0

;;;;;;;;;;;;;;;;;;;
;; ENTIDADES FONDO
;;;;;;;;;;;;;;;;;;;

tronco::
    .db TYPE_FONDO
    .db CMP_RENDER | CMP_ANIMATED                  ;; CMP
    .db 50                           ;; X
    .db 150                                ;; Y (PLAYERSHIPY - 8)
    .db SPR_TRONCO_W                        ;; Width
    .db SPR_TRONCO_H             ;; Height
    .db 0                                       ;; vx
    .db 0                                       ;; vy
    .dw _spr_tronco_pompa_0                              ;; puntero a sprite
    .dw 0
    .db 0                                       ;; ai_counter
    .db 0                                         ;; collides_against
    .db anim_tronco_time
    .dw animation_tronco
    .dw 0                                       ;; previous video position
    .dw 0



misil::
    .db TYPE_ENEMYSHOT
    .db CMP_MOVABLE | CMP_RENDER  | CMP_COLLIDER  | CMP_AI      ;; CMP
    .db 0                                       ;; X
    .db 172                                     ;; Y (PLAYERSHIPY - 8)
    .db SPR_MISIL_W                            ;; Width
    .db SPR_MISIL_H                            ;; Height
    .db -1                                      ;; vx
    .db 0                                       ;; vy
    .dw _spr_misil                             ;; puntero a sprite
    .dw sys_ai_behaviour_torpedo
    .db 0                                      ;; ai_counter
    .db TYPE_PLAYER                              ;; collides_against
    .db 0
    .dw 0
    .dw 0                                       ;; previous video position
    .dw 0

explosion::
    .db TYPE_ENEMYSHOT
    .db CMP_MOVABLE | CMP_RENDER  | CMP_COLLIDER  | CMP_AI | CMP_ANIMATED      ;; CMP
    .db 0                                       ;; X
    .db 172                                     ;; Y (PLAYERSHIPY - 8)
    .db SPR_PLAYERSHIP_W                            ;; Width
    .db SPR_PLAYERSHIP_H                            ;; Height
    .db 0                                      ;; vx
    .db 0                                       ;; vy
    .dw _spr_explosion_0                             ;; puntero a sprite
    .dw sys_ai_behaviour_autodestroy
    .db 12                                     ;; ai_counter
    .db TYPE_PLAYER                              ;; collides_against
    .db 0
    .dw 0
    .dw 0                                       ;; previous video position
    .dw 0

enemysub::
    .db TYPE_ENEMY
    .db CMP_RENDER | CMP_MOVABLE | CMP_AI | CMP_COLLIDER  | CMP_ANIMATED
    .db 70
    .db 5
    .db SPR_SUBMACA_W
    .db SPR_SUBMACA_H
    .db -1
    .db 0
    .dw _spr_submaca_0
    .dw sys_ai_behaviour_submarino
    .db counter_submarine_change                                   ;; ai_counter
    .db TYPE_PLAYER                             ;; collides_against
    .db anim_enemy1_time
    .dw animation_submaca
    .dw 0                                       ;; previous video position
    .dw misil          

_init_entities::
    ;; inicializar array con ceros
    ;; (2B DE) array	Pointer to the first byte of the array to be filled up (starting point in memory)
    ;; (1B A ) value	8-bit value to be set
    ;; (2B BC) size	Number of bytes to be set (>= 2)
    ld de, #_entities ;; asks for a pointer, not the memory address
    ld a, #0
    ld bc, #ARRAY_SIZE
    call cpct_memset_asm
    ld a, #0
    ld (_active_entities), a
    ld a, #TYPE_INVALID
    ld (_zero_value_at_the_end), a
    ld hl, #_entities
    ld (_next_free_entity), hl                 ;; sin los parentesis cambiaria la dir de memoria a la que apunta el puntero y no el valor en memoria
    ret



;; OUTPUT: HL - Dir de memoria del entity
_createEntity::
    ld hl, #_active_entities
    inc (hl)

    ld bc, (_next_free_entity)
    ld hl, #ENTITY_SIZE
    add hl, bc
    ld (_next_free_entity), hl
    
    push bc
    pop ix

    ld type(ix),    #TYPE_DEFAULT
    ld cmp(ix),     #CMP_DEFAULT

	ld	l, c
	ld	h, b

    ret

;;;;;;;;;;;;;;;;;;;;
;; INPUT: DE -> Pointer a la entidad a destruir
;;;;;;;;;;;;;;;;;;;;
_destroyEntity::
    ld a, (_active_entities)
    dec a
    ld (_active_entities), a
    
    ld hl, (_next_free_entity)
    ld bc, #-ENTITY_SIZE
    add hl, bc    ;; a -= 5       Recolocamos la next_free_entity
    ld (_next_free_entity), hl
    ;;(2B DE) to	Pointer to the destination (first byte where bytes will be written)
    ;;(2B HL) from	Pointer to the source (first byte from which bytes will be read)
    ;;(2B BC) size	Number of bytes to be set (>= 1)

    push hl
    ld bc, #ENTITY_SIZE
    call cpct_memcpy_asm

    pop hl

    ld (hl), #TYPE_INVALID
    ld (_next_free_entity), hl      ;; actualizamos next_free_entity

    ret 