
.area _DATA

.area _CODE
.globl _main_palette

.include "cpctelera.h.s"
.include "manager/manager.h.s"
.include "system/system.h.s"
.include "defineValues.h.s"
.include "cpct_includes.h.s"
.include "entity.h.s"
.include "manager/game.h.s"

.globl _sfx_sounds
.globl _cancion2
.globl renderVictoria
.globl sys_check_space_or_esc_pressed

;;;;;;;;;;;;;;;;;;;;
;; FUNCIONES
;;;;;;;;;;;;;;;;;;;;

variable:
    .db 6
interruptHandler::
    push af
    push bc
    push de
    push hl
    push iy

    ld a, (variable)
    dec a
    ld (variable), a
    jr nz, return

    call cpct_akp_musicPlay_asm
    ld a, #6
    ld (variable), a

    return:
    pop iy
    pop hl
    pop de
    pop bc
    pop af

    ret


_main::
;;;;;;;;;;;;;;;;;;;;
;; CONFIGURAR VIDEO
;;;;;;;;;;;;;;;;;;;;

    call cpct_disableFirmware_asm
    ld de, #_cancion2
    call cpct_akp_SFXInit_asm
    ld de, #_cancion2
    call cpct_akp_musicInit_asm

    ld hl, #interruptHandler
    call cpct_setInterruptHandler_asm

    ld c, #0
    call cpct_setVideoMode_asm
    cpctm_setBorder_asm HW_BLACK
    ld l, #0
    ld h, #HW_BLACK
    call cpct_setPALColour_asm

    ld hl, #_main_palette
    ld de, #16
    call cpct_setPalette_asm


;;;;;;;;;;;;;;;;;;;;
;; MAIN
;;;;;;;;;;;;;;;;;;;;
    nivel_no_superado:
        call man_game_init
        ld iy, #0x0101
        call man_game_play
        ld iy, #m_game_counter
        call man_check_counter_zero_or_decrease
        cp #0
        jr nz, nivel_no_superado
;
    nivel_2_no_superado:
        call man_game_init_lvl_2
        ld iy, #0x0202
        call man_game_play
        ld iy, #m_game_counter
        call man_check_counter_zero_or_decrease
        cp #0
        jr nz, nivel_2_no_superado
    nivel_3_no_superado:
        ;; implementar lvl 3
        call man_game_init_lvl_3
        ld iy, #0x0303
        call man_game_play
        
        ld iy, #m_game_counter
        call man_check_counter_zero_or_decrease
        cp #0
        
        jr nz, nivel_3_no_superado

        ;; meter pantalla

        call renderVictoria
        bucleVictory:
        ld a, #0
        call sys_check_space_or_esc_pressed

        cp #1
        jr nz, bucleVictory

    ld a, #0
    ld (m_first_time_game_init), a
    jr nivel_no_superado                  ;; vuelve a la portada


    ret


;; puntero a memoria con esos valores

_palette:
    .ds #32

    