.area _DATA

.area _CODE
.include "cpctelera.h.s"
.include "cpct_includes.h.s"
.include "defineValues.h.s"
.include "entity.h.s"
.include "system/system.h.s"
.include "system/animations.h.s"
.include "system/collision.h.s"
.include "map.h.s"
.include "manager/manager.h.s"

.globl _entities
.globl _active_entities
.globl sys_render_one_entity            ;;BORRAR
.globl sys_physics_update_one_entity    ;;BORRAR
.globl _destroyEntity
.globl sys_render_clear
.globl renderLoadingScreen
.globl renderPortada
.globl sys_check_space_or_esc_pressed
.globl _spr_lvl1
.globl _spr_lvl2
.globl _spr_lvl3
.globl renderDeathScreen
.globl _cancion2
.globl  renderFondo
.globl tronco
.globl enemysub
.globl render_remove_shots_counter
.globl render_add_shots_counter

m_game_counter::
    .dw lvl1_counter

m_enemy_shot_counter:
    .db counter_enemy_shot

r_loading_screen_counter::
    .dw counter_loading

m_first_time_game_init::
    .db 0

m_shots_left::
    .db 5

m_counter_add_shot:
    .db counter_add_shot

draw_borders:
    ld de, #0xC000
    ld a, #0
    ld c, #4
    ld b, #200
    call cpct_drawSolidBox_asm
    ld de, #0xC000
    ld c, #76
    ld b, #0
    call cpct_getScreenPtr_asm
    ex de, hl
    ld a, #0
    ld c, #4
    ld b, #200
    call cpct_drawSolidBox_asm
    ret

;; INPUT DE - Game_counter_lvlX
man_game_initialize_memory_data::
    ld a, #0
    ld (m_player_shot), a
    ld (m_enemy_alive), a
    ld (m_enemy_shot), a

    ld a, #5
    ld (m_shots_left), a

    ld a, #counter_enemy_gen
    ld (m_enemy_gen_counter), a

    ex de, hl
    ld (m_game_counter), hl

    ld a, #counter_enemy_shot
    ld (m_enemy_shot_counter), a

    ld hl, #60000
    ld (r_loading_screen_counter), hl
    ret


man_game_init::
    ld de, #lvl1_counter
    call man_game_initialize_memory_data
    call _init_entities

    ld hl, #playership
    call man_create_template_entity  

    ld hl, #enemy2
    call man_create_template_entity
    ld a, #1
    ld (m_enemy_alive), a


    ld a, (m_first_time_game_init)
    cp #0
    jr nz, noPortada

    ld a, #1
    ld (m_first_time_game_init), a          ;; Ya no vuelve a aparecer la portada
    
    call renderPortada
    renderPortadaBucle:

    ld a, #0
    call sys_check_space_or_esc_pressed

    cp #1
    jr nz, renderPortadaBucle

    noPortada:
    ld hl, #_spr_lvl1
    call renderLoadingScreen

    call sys_render_clear
    
    ret

;; INPUT IY - LEVEL
man_game_play::
    push iy

    call renderFondo
    call draw_borders
    loop:
        ld iy, #m_game_counter

        call man_check_counter_zero_or_decrease
        cp #0
        jr z, nivel_2

        loopJuego:
        call man_game_check_add_shot
        call sys_collision_update
        
        call sys_render_update
        call man_entity_delete
        call sys_input_update
        call sys_physics_update
        pop iy
        call man_game_enemy_generator
        push iy
        call sys_ai_update


        call sys_animation_update
        ;;call draw_map
        ;;call map_scrollRight

        call cpct_waitVSYNC_asm
        checkPlayerAlive:
        ld a, (_entities)
        cp #TYPE_PLAYER
        jr z, loop

        pop iy                  ;; OJO CON LOS POPS
        call sys_render_clear


        call renderDeathScreen

        renderGameOverBucle:
            ld a, #0
            call sys_check_space_or_esc_pressed
            cp #1
            jr nz, renderGameOverBucle
            ret
   
        ret
        nivel_2:
        pop iy
        ;; cuando el counter llega a cero, completaste el nivel
    ret

man_game_init_lvl_2::
    ld de, #lvl2_counter
    call man_game_initialize_memory_data
    call _init_entities

    ld hl, #playership
    call man_create_template_entity  

    ld hl, #tiburonRojoTemplate
    call man_create_template_entity
    ld a, #1
    ld (m_enemy_alive), a

    ld hl, #_spr_lvl2
    call renderLoadingScreen

    call sys_render_clear
    call draw_borders

    ret
ret

man_game_init_lvl_3::
    ld de, #lvl3_counter
    call man_game_initialize_memory_data
    call _init_entities

    ld hl, #playership
    call man_create_template_entity  

    ld hl, #enemysub
    call man_create_template_entity
    ld a, #1
    ld (m_enemy_alive), a

    ld hl, #_spr_lvl3
    call renderLoadingScreen

    call sys_render_clear
    call draw_borders

    ret
ret

;; INPUT IX - Memory address to entity
man_game_entity_destroy::

    ld a, type(ix)
    and #TYPE_SHOT
    jr z, entityNOTShot 

    ;; entity is shot 
    ld a, (m_player_shot)
    ld a, #0
    ld (m_player_shot), a


    entityNOTShot:

    ld a, type(ix)
    and #TYPE_ENEMY
    jr z, entityNOTEnemy

    push ix
    ld l, #1
    ld h, #15
    ld e, #143
    ld d, #0
    ld bc, #0
    ld a, #4
    call cpct_akp_SFXPlay_asm
    pop ix


    ld a, (m_enemy_alive)
    ld a, #0
    ld (m_enemy_alive), a
    

    entityNOTEnemy:

    push ix
    pop de
    call _destroyEntity
    
    ;;(1B L ) sfx_num	Number of the instrument in the SFX Song (>0), same as the number given to the instrument in Arkos Tracker.
    ;;(1B H ) volume	Volume [0-15], 0 = off, 15 = maximum volume.
    ;;(1B E ) note	Note to be played with the given instrument [0-143]
    ;;(1B D ) speed	Speed (0 = As original, [1-255] = new Speed (1 is fastest))
    ;;(2B BC) inverted_pitch	Inverted Pitch (-0xFFFF -> 0xFFFF).  0 is no pitch.  The higher the pitch, the lower the sound.
    ;;(1B A ) channel_bitmask	Bitmask representing channels to use for reproducing the sound (Ch.A = 001 (1), Ch.B = 010 (2), Ch.C = 100 (4))




    ret 

man_game_check_add_shot:
    ld a, (m_counter_add_shot)

    cp #0
    jr nz, exit

    ;;time to add a shot for the player
    ld a, (m_shots_left)
    cp #max_player_shots
    jr z, alreadyMaxShots
    inc a
    ld (m_shots_left), a
    
    call render_add_shots_counter
    alreadyMaxShots:

    ld a, #counter_add_shot
    ld (m_counter_add_shot), a

    ret

    exit:
    dec a
    ld (m_counter_add_shot), a

    ret


;; INPUT IX - Player entity
man_game_player_shot::
    ;;checks there is not shot
    ld a, (m_player_shot)
    cp #0
    jr z, create_shot
   
    ;;(1B L ) sfx_num	Number of the instrument in the SFX Song (>0), same as the number given to the instrument in Arkos Tracker.
    ;;(1B H ) volume	Volume [0-15], 0 = off, 15 = maximum volume.
    ;;(1B E ) note	Note to be played with the given instrument [0-143]
    ;;(1B D ) speed	Speed (0 = As original, [1-255] = new Speed (1 is fastest))
    ;;(2B BC) inverted_pitch	Inverted Pitch (-0xFFFF -> 0xFFFF).  0 is no pitch.  The higher the pitch, the lower the sound.
    ;;(1B A ) channel_bitmask	Bitmask representing channels to use for reproducing the sound (Ch.A = 001 (1), Ch.B = 010 (2), Ch.C = 100 (4))
    
    ret

    create_shot:

        ld a, (m_shots_left)

        cp #0
        jr z, noSpace

        ;; quedan disparos

        dec a
        ld (m_shots_left), a

        push ix
        ld l, #2
        ld h, #15
        ld e, #70
        ld d, #0
        ld bc, #0
        ld a, #4
        call cpct_akp_SFXPlay_asm
        pop ix
        push ix
        ;;create new shot
        ld hl,#playershot
        call man_create_template_entity
        pop iy                              ;; iy = player entity
        ld a, y(iy)
        add #2
        ld y(ix), a                         ;; shot_y = player_y + 2

        ld a, (m_player_shot)
        inc a
        ld (m_player_shot),a

        call render_remove_shots_counter
    noSpace:
    ret   
 
;; INPUT IY - LEVEL
man_game_enemy_generator::

    ld a, (m_enemy_alive)
    cp #0

    jr z, createEnemy
    ret

    createEnemy:                                    ;; ENTRA EN CREATEENEMY ->  empieza el cooldown

    ld a, #0
    ld (m_enemy_shot_counter), a


    ld a, (m_enemy_gen_counter)
    cp #0
    jr nz, dontCreate

    ld a, #counter_enemy_gen
    ld (m_enemy_gen_counter), a

    ;; AQUI EMPIEZA LA PARTE DE CREAR ENEMIGO

    push iy
    pop af

    cp #2
    jr z, level2
    cp #3
    jr z, level3
    level1:

    ld hl, #enemy2
    call man_create_template_entity
    jr enemyTemplateAssigned
    level2:
    push de
    push bc
    push hl
    call cpct_getRandom_xsp40_u8_asm
    pop hl
    pop bc
    pop de

    sub #128
    jr nc, createNormalShark
    ;; createRedShark
    ld hl, #tiburonRojoTemplate
    call man_create_template_entity
    jr enemyTemplateAssigned

    createNormalShark:
    ld hl, #enemy2
    call man_create_template_entity
    jr enemyTemplateAssigned

    level3:
    push de
    push bc
    push hl
    call cpct_getRandom_xsp40_u8_asm
    pop hl
    pop bc
    pop de

    sub #128
    jr nc, createSubmaca
    ;; createRedShark
    ld hl, #tiburonRojoTemplate
    call man_create_template_entity
    jr enemyTemplateAssigned

    createSubmaca:
    ld hl, #enemysub
    call man_create_template_entity
    jr enemyTemplateAssigned


    enemyTemplateAssigned:

    ld a, #0
    ld (m_enemy_shot), a
    ld a, #1
    ld (m_enemy_alive), a


    ;; ASIGNAR Y ALEATORIA
    push de
    push bc
    push hl
    call cpct_getRandom_xsp40_u8_asm
    pop hl
    pop bc
    pop de
    ;; returns in A
    ld b, a
    sub #max_y 
    jr c, numeroBueno ;; si hay carry, el numero era menor que max_y
    cp #6
    jr nc, numeroBueno3
    ;; numero con la resta
    ld a, #5
    numeroBueno3:
    ld y(ix), a
    ret
    numeroBueno:
    ld a, b
    cp #6
    jr nc, numeroBueno2
    ld a, #5
    numeroBueno2:

    ld y(ix), a

    ret
    dontCreate:
    dec a
    ld (m_enemy_gen_counter), a
    ret



man_game_enemy_shot::
    ;;checks there is not shot
    ld a, (m_enemy_shot_counter)
    cp #0
    jr z, create_en_shot
    dec a
    ld (m_enemy_shot_counter), a 
    ret
    create_en_shot:
        ld a, #counter_enemy_shot
        ld (m_enemy_shot_counter), a
        push ix
        ;;create new shot
        ld l, type_shot(ix)
        ld h, type_shot+1(ix)
        call man_create_template_entity
        pop iy                              ;; iy = player entity
        ld a, x(iy)
        add #-8
        ld x(ix), a                         ;; shot_y = player_y + 2

        ld a, y(iy)
        ld y(ix), a

        ld a, (m_enemy_shot)
        ld a, #1
        ld (m_enemy_shot),a
    
    ret   