.area _DATA

.area _CODE
.include "cpctelera.h.s"
.include "cpct_includes.h.s"
.include "defineValues.h.s"
.include "entity.h.s"
.include "system/system.h.s"
.include "manager/game.h.s"

.globl _entities
.globl _active_entities
.globl sys_render_one_entity            ;;BORRAR
.globl sys_physics_update_one_entity    ;;BORRAR
.globl _destroyEntity
.globl sys_render_clear
.globl renderLoadingScreen



;;No player shots on start
m_player_shot::
    .db 0
m_lane_status::
    .db 0
    .db 0
    .db 0

m_enemy_shot::
    .db 0

m_enemy_alive::
    .db 0

m_enemy_gen_counter::
    .db counter_enemy_gen




;;;;;;;;;;;;;;;;;;;;
;; FUNCIONES MANAGER
;;;;;;;;;;;;;;;;;;;;

;; RECEIVES A COUNTER OF 2 BYTES!!!!
;; INPUT IY - Memory of counter

;; OUTPUT A - 0 | Counter is 0
;;        A - 1 | Counter was not zero, so it was decreased
man_check_counter_zero_or_decrease::
        ld a, (iy) ;; byte bajo 
        cp #0
        jr z, checkByteAlto
        ;;no es cero: decrementa y devuelve A=1
        dec a
        ld (iy), a
        
        ld a, #1

        ret

        checkByteAlto:
        ;; decrementa el byte bajo para que se resetee al valor max
        dec a
        ld b, a                                                     ;; b tiene el valor del byte bajo - 1

        ld a, 1(iy)
        cp #0
        jr z, counterEsZero
        ;; no es cero: decrementa y sigue el juego
        dec a
        ld 1(iy), a
        ld (iy), b
        ld a, #1

        ret
        counterEsZero:
        ld a, #0
        ret




;; TODO: Si no hay espacio, avisar de algun modo???? Si no operamos con IX cuando no toca

;; INPUT:   HL entityTemplate
;; OUTPUT:  IX direccion de memoria de entity
man_create_template_entity::

    ;; CHECK IF THERE IS ENOUGH SPACE
    push hl
    call man_entity_free_space
    ;; output a -> num_of_entities that can be created

    cp #0
    jr z, noSpaceForNewEntity


    call _createEntity
    push hl
    pop ix      ;; meter en ix la dir de memoria de la entity creada

    ;; (2B DE) to	Pointer to the destination (first byte where bytes will be written)
    ;; (2B HL) from	Pointer to the source (first byte from which bytes will be read)
    ;; (2B BC) size	Number of bytes to be set (>= 1)
    ex de, hl
    pop hl
    ld bc, #ENTITY_SIZE              ;; mothership entity is 9bytes (sprite is 2)

    call cpct_memcpy_asm

    noSpaceForNewEntity:
    ld a, #-1
    ret

;;;;;;;;;;;;;;;;;;;;
;; INPUT:   HL -> Puntero a funcion (void) func -> Entity_t
;;          B -> signature (8 bits)
;;
;; Realmente en HL solo esta la direccion de memoria que queremos meter en PC
;;;;;;;;;;;;;;;;;;;;
man_update_forall_matching::
    
    ld ix, #_entities
    inicioLoopUpdate:
        ;; if entity->type == INVALID
        ;;      END;
        ld a, type(ix)                      ;; a = entity->type 
        cp #TYPE_INVALID    
        jr z, finLoopUpdate

;;  ###########                         ;; CHECK SIGNATURE (COMPONENT)
        ld a, cmp(ix)
        and b
        cp b
        jr z, itsMatching
        jr noMatching

        itsMatching:
        push hl                         ;; en la funcion se modifica HL
        push ix
        push bc
        ld de, #direccionDeVuelta      ;; METEMOS LA DIR A LA QUE VOLVER EN LA PILA
        push de                         ;; AL EJECUTAR RET, SE COPIARA AL PC LO QUE HAYA EN 0(SP), 1(SP)

        jp (hl)                         ;; call function through pointer???
        direccionDeVuelta:
        pop bc
        pop ix
        pop hl
        
        noMatching:
        ld de, #ENTITY_SIZE
        add ix, de

        jr inicioLoopUpdate

    finLoopUpdate:
    ret   

;;;;;;;;;;;;;;;;;;;;
;; INPUT:   HL -> Puntero a funcion (void) func -> Entity_t
;;          B -> signature (8 bits)
;;
;; Realmente en HL solo esta la direccion de memoria que queremos meter en PC
;;;;;;;;;;;;;;;;;;;;
man_update_forall_pairs_matching::
    ld ix, #_entities
    inicioLoopUpdatePairs:
        ;; if entity->type == INVALID
        ;;      END;
        ld a, type(ix)                          ;; a = entity->type 
        cp #TYPE_INVALID    
        jr z, finLoopUpdatePairs

        ;;  ###########                         ;; CHECK SIGNATURE (COMPONENT)
        ld a, cmp(ix)
        and b
        cp b
        jr nz, noMatchingPairs
            ;; FIRST ENTITY MATCHES
            push ix
            pop iy

            ld de, #ENTITY_SIZE
            add iy, de                          ;; iy = nextEntity(ix)
            inicioLoopInterno:
            ld a, type(iy)                      ;; a = entity->type 
            cp #TYPE_INVALID    
            jr z, noMatchingPairs               ;; incrementamos la variable primera cuando llegamos al final
            ;;  ###########                     ;; CHECK SIGNATURE (COMPONENT)
            ld a, cmp(iy)
            and b
            cp b
            jr nz, noMatchingInterno
            ;; SECOND ENTITY MATCHES
                push hl                         ;; en la funcion se modifica HL
                push ix
                push iy
                push bc
                ld de, #direccionDeVueltaPairs      ;; METEMOS LA DIR A LA QUE VOLVER EN LA PILA
                push de                         ;; AL EJECUTAR RET, SE COPIARA AL PC LO QUE HAYA EN 0(SP), 1(SP)
                ;; input: IX, IY
                jp (hl)                         ;; call function through pointer???
                direccionDeVueltaPairs:
                pop bc
                pop iy
                pop ix
                pop hl                

            noMatchingInterno:
            ld de, #ENTITY_SIZE
            add iy, de
            jr inicioLoopInterno

        noMatchingPairs:
        ld de, #ENTITY_SIZE
        add ix, de
        jr inicioLoopUpdatePairs
    finLoopUpdatePairs:

    ret

;;;;;;;;;;;;;;;;;;;;
;; INPUT: DE -> Puntero a entidad
;;;;;;;;;;;;;;;;;;;;
man_entity_set4destruction::
    ;; Marca el byte dead
    ld h, d
    ld l, e
    ld a, (hl)
    or #TYPE_DEAD
    ld (hl), a
    
    ret

;;;;;;;;;;;;;;;;;;;;
;; OUTPUT: A -> Numero de espacios para estrella libres
;;;;;;;;;;;;;;;;;;;;
man_entity_free_space::
    ld a, #MAX_ENTITIES
    ld hl, #_active_entities
    sub (hl)
    ;; output is A

    ret


man_entity_delete::
    ld hl, #_entities
    inicioLoopDelete:
        ;; if entity->type == INVALID
        ;;      END;
        ld a, (hl) ; a = entity->type 
        cp #TYPE_INVALID
        jr z, finLoopDelete

        ld a, (hl)                              ;; cargamos de nuevo por si acaso
        and #TYPE_DEAD
        jr z, no_dead_increment
        push hl
        pop ix
        push hl
        call man_game_entity_destroy 
        pop hl
        jr inicioLoopDelete                     ;; No incrementamos al destruir

    no_dead_increment:
        ld de, #ENTITY_SIZE
        add hl, de

        jr inicioLoopDelete

    finLoopDelete:
    ret





