.include "defineValues.h.s"
.include "manager/manager.h.s"
.include "manager/game.h.s"
.include "cpct_includes.h.s"
.include "entity.h.s"
.globl _entities
.globl man_game_enemy_shot

.globl SPR_PLAYERSHIP_H
.globl SPR_PLAYERSHIP_W
.globl _spr_explosion_0

no_ai::
    ret
;; INPUT : IX - Dir de memoria de entity
sys_ai_update_one_entity:
    ld a, behaviour(ix)
    ld l, a
    ld a, behaviour+#1(ix)
    ld h,a
    ld de, #salir_ai
    push de
    jp (hl)
    salir_ai:
    ret


sys_ai_update::
    ld hl, #sys_ai_update_one_entity
    ld b, #CMP_RENDER | CMP_MOVABLE | CMP_AI
    call man_update_forall_matching

    ret


;; INPUT : IX - Dir de memoria de entity
sys_ai_behaviour_autodestroy::
    ld a, counter(ix)
    dec a
    ld counter(ix), a
    jr z, counter_is_zero
    ret

    counter_is_zero:
        push ix
        pop de
        call man_entity_set4destruction
    
    ret

;; INPUT: IX - Entity memory position
sys_ai_behaviour_follow_player_y::

    ld a, x(ix)
    cp #0
    jr nz, accion
    push ix
    pop de
    call man_entity_set4destruction
    ret

    accion:

    


    ld vx(ix), #-1
    ld a, y(ix)
    ld iy, #_entities           ;; OJO CON ESTO
    ld b, y(iy)
    ld c, #SPR_PLAYERSHIP_H

    cp b
    jr z, iszero
    jr nc, subir
    jr c, bajar
    subir:
        ld vy(ix), #-2
        jr salir

    bajar:
        ld vy(ix), #2
        jr salir
    iszero:
        ld vy(ix), #0
 
    salir:

    ret

    

;; INPUT: IX - Entity memory position
sys_ai_zigzag::
    ld a, counter(ix)
    dec a
    ld counter(ix), a
    jr z, changeVY
    ret
    changeVY:
        ld b, vy(ix)
        ld a, #0
        sub b

        ld vy(ix), a
        ld a, #zigzag_counter
        ld counter(ix), a
ret

sys_ai_behaviour_enemy::
    ld a, counter(ix)
    cp #0
    jr nz, decrementar 

    ld counter(ix), #counter_enemy_move

    call sys_ai_behaviour_follow_player_y
    call sys_ai_behaviour_shot
    jr sal_enemy
    decrementar:
        dec a
        ld counter(ix), a
        ld vx(ix), #0
        ld vy(ix), #0

    sal_enemy:

    ret

sys_ai_behaviour_shot::
    ld iy, #_entities
    ld a, x(ix)
    ld b, x(iy)
    cp b
    jr c, salir_shot
    
    ld a, y(ix)
    
    ld b, y(iy)
    ld c, #SPR_PLAYERSHIP_H

    sub b

    ld a, y(ix)
    
    ld b, y(iy)
    sub b
    jr z, disparar
    jr c, arriba
    jr nc, abajo

    abajo:
        sub c
        jr z, disparar
        jr c, disparar
        jr salir_shot
    
    arriba: 
        add c
        jr z, disparar
        jr c, disparar
        jr salir_shot

    disparar:
        ;ld a, #0
        ;ld vy(ix), a
        call man_game_enemy_shot
        jr salir_shot
    



    salir_shot:
    
    ret

sys_ai_behaviour_submarino::
    call sys_ai_movement_submarino
    call sys_ai_behaviour_shot
    ret

sys_ai_movement_submarino::

    ld a, x(ix)
    cp #50
    jr z, comportamiento

    ld vx(ix), #-1
    jr salir2
    comportamiento:
    ld vx(ix), #0

    ld a, counter(ix)
    cp #0
    ld counter(ix), #counter_submarine_change
    jr nz, deccounter
;   
    ;ld a, y(ix)
    ;cp #5
    ;jr nz, up
    ;ld vy(ix), #1
    ;jr salir2
    ;up:
    ;cp #100
    ;jr nz, salir2
    ;ld vy(ix), #-1
    calcspeed:
    call cpct_getRandom_xsp40_u8_asm
    and #3
    sub #1
    ld b, a
    call cpct_getRandom_xsp40_u8_asm
    sub #128
    jr c, rest
    ld a, #0
    sub b
    rest:
    ld vy(ix), b
    ld a, vy(ix)
    cp #0
    jr z, calcspeed
    jr salir2
    deccounter:
        dec a
        ld counter(ix), a
        
    salir2:
    
    ret


sys_ai_behaviour_torpedo::
    ld iy, #_entities
    ld a, x(ix)
    ld b, x(iy)

    cp b

    jr z, explode
    jr salirtorpedo

    explode:
        push ix
        pop de

        ;call man_entity_set4destruction
        ;ld hl, #explosion
        ;push ix
        ;call man_create_template_entity
        ;pop iy
        ;ld a, y(iy)
        ;add #5
        ;ld y(ix), a
        ;ld a, x(iy) 
        ;ld x(ix), a
        ;ld hl, #explosion
        ;push ix
        ;call man_create_template_entity
        ;pop iy
        ;ld a, y(iy)
        ;sub #SPR_PLAYERSHIP_H
        ;ld y(ix), a
        ;ld a, x(iy) 
        ;ld x(ix), a
        ld hl, #_spr_explosion_0
        ld sprite+1(ix), h
        ld sprite(ix), l
        ld vx(ix), #0
        ld width(ix), #SPR_PLAYERSHIP_W
        ld height(ix), #SPR_PLAYERSHIP_H
        ld hl, #sys_ai_behaviour_autodestroy
        ld behaviour+1(ix), h
        ld behaviour(ix), l
        ld counter(ix), #12

    salirtorpedo:
    

    ret
