.include "defineValues.h.s"
.include "cpct_includes.h.s"
.include "manager/manager.h.s"
.include "system/ai.h.s"
.include "system/animations.h.s"
.globl _spr_explosion_0
.globl _spr_explosion_1
.area _CODE


PLAYER_COMPONENTS = CMP_RENDER | CMP_MOVABLE | CMP_INPUT | CMP_COLLIDER | CMP_ANIMATED | CMP_AI 

sys_collision_update::


    ld hl, #sys_collision_update_two_entities
    ld b, #CMP_COLLIDER
    call man_update_forall_pairs_matching

    ret

;; INPUT IX - Mem. position of entity1
;;       IY - Mem. position of entity2
sys_collision_update_two_entities::

    ld a, type(iy)
    ld c, collides_against(ix)
    and collides_against(ix)
    ld c, a
    
    ld a, type(ix)
    and collides_against(iy)
    
    or c
    jr nz, collidingObjects
    ret

    collidingObjects:
    ;; Check bounding boxes
                                    ;; e1->y < e2->y+e2->height??
        ld b, y(ix)
        ld a, y(iy)
        ld c, height(iy)

        add c
        
        sub b                       ;; e2->y+e2.height - e1.y
        jr nc, yLower
        ret
        
        yLower:
                                    ;; e1.y+e1.height >= e2->y
        ld a, y(ix)
        ld b, y(iy)
        ld c, height(ix)

        add c
        
        sub b                       ;; e1->y+e1.height - e2.y
        jr nc, collisionY
        ret

        collisionY:
            ;; CHECK COLLISION X
                                    ;; e1->x < e2->x+e2->width??
            ld b, x(ix)
            ld a, x(iy)
            ld c, width(iy)

            add c
            
            sub b                       ;; e2->x+e2.width - e1.x
            jr nc, xLower
            ret
            
            xLower:
                                        ;; e1.y+e1.height >= e2->y
            ld a, x(ix)
            ld b, x(iy)
            ld c, width(ix)

            add c
            sub b                       ;; e1->y+e1.height - e2.y
            jr nc, collisionConfirmed
            ret

            collisionConfirmed:

                ;; DELETE BULLET AND ENEMY
                push ix
                pop de
                ld a, (ix)
                cp #TYPE_PLAYER
                jr z, player_1
                call man_entity_set4destruction
                jr startplayer2
                player_1:
                    ld hl, #sys_ai_behaviour_autodestroy
                    ld behaviour+1(ix), h
                    ld behaviour(ix), l
                    
                    ld vy(ix), #0
                    ld a, counter(ix)
                    cp #0
                    jr nz, startplayer2
                    ld hl, #_spr_explosion_0
                    ld sprite+1(ix), h
                    ld sprite(ix), l
                    ld counter(ix), #24
                    ld anim_counter(ix), #anim_enemy1_time
                    ld hl, #animation_explosion
                    ld anim+1(ix), h
                    ld anim(ix), l
                    ld a, #PLAYER_COMPONENTS
                    xor #CMP_INPUT
                    ld cmp(ix), a


                startplayer2:
                    push iy
                    pop de
                    ld a, (iy)
                    cp #TYPE_PLAYER
                    jr z, player_2
                    call man_entity_set4destruction
                    player_2:
                        ld hl, #sys_ai_behaviour_autodestroy
                        ld behaviour+1(ix), h
                        ld behaviour(ix), l
                        
                        
                        
                        ld vy(ix), #0
                        ld a, counter(iy)
                        cp #0
                        jr nz, endcoll
                        
                        ld a, #PLAYER_COMPONENTS
                        xor #CMP_INPUT
                        ld cmp(ix), a
                        ld hl, #animation_explosion
                        ld anim+1(ix), h
                        ld anim(ix), l
                        ld hl, #_spr_explosion_0
                        ld sprite+1(ix), h
                        ld sprite(ix), l
                        ld counter(iy), #24
                        ld anim_counter(iy), #anim_enemy1_time
                        endcoll:
    ret