.include "defineValues.h.s"
.include "manager/manager.h.s"
.include "manager/game.h.s"
.include "cpct_includes.h.s"
.include "cpctelera.h.s"
;; INPUT: IX -> Dir. memoria del entity
sys_physics_update_one_entity::

    ld a, vx(ix)     ;; a = entity->vx  
    add a, x(ix)     ;; a = entity->x + entity->vx

    

    ld x(ix), a

    
    cp #0
    jr c, destroy
    jr z, destroy


    ld a, vy(ix)     ;; update vy as well
    add a, y(ix)

    cp #6
    jr nc, mayory
    ld a, #5
    jr cargary
    mayory:
    cp #141
    jr c, cargary
    ld a, #max_y

    cargary:
    ld y(ix), a

    ret


    destroy:
    push ix
    pop de
    call man_entity_set4destruction

    ret

sys_physics_update::
    ld hl, #sys_physics_update_one_entity
    ld b, #CMP_MOVABLE
    call man_update_forall_matching

    ret

sys_input_update::
    ld hl, #sys_physics_check_keyboard
    ld b, #CMP_INPUT
    call man_update_forall_matching

    ret

;; OUTPUT: A = 0 | BOTH NOT PRESSED    A = 1 | SPACE PRESSED    A = 2 | ESC PRESSED
sys_check_space_or_esc_pressed::
    call cpct_scanKeyboard_f_asm
    ld hl, #Key_Space
    call cpct_isKeyPressed_asm
    cp #0
    jr z, spaceNotPressed
    ;; SPACE PRESSED
    ld a, #1
    ret

    spaceNotPressed:
    call cpct_scanKeyboard_f_asm
    ld hl, #Key_Esc
    call cpct_isKeyPressed_asm
    cp #0
    jr z, bothNotPressed
    ;; ESC PRESSED
    ld a, #2
    ret
    
    bothNotPressed:
    ld a, #0
    ret

;; INPUT IX - Dir de memoria de entity
sys_physics_check_keyboard::
    call cpct_scanKeyboard_f_asm
    ld vy(ix), #0

    ;; HL - Key
    ld hl, #Key_Q
    call cpct_isKeyPressed_asm
    push af
    ld hl, #Joy0_Up
    call cpct_isKeyPressed_asm
    pop bc
    or b
    cp #0                           ;; A is 0 -> not pressed        else -> pressed
    jr z, checkNextKey

    ;; IS PRESSED

    ld a, y(ix)
    sub #min_y
    jr c, endCheckMovement          ;; Player cant move higher (screen limit)

    ld vy(ix), #-2
    jr endCheckMovement
    checkNextKey:
    
    ld hl, #Key_A
    call cpct_isKeyPressed_asm
    push af
    ld hl, #Joy0_Down
    call cpct_isKeyPressed_asm
    pop bc
    or b
    cp #0
    jr z, endCheckMovement
    ;; IS PRESSED
    ld a, y(ix)
    cp #max_y
    jr z, endCheckMovement          ;; Player cant move lower (screen limit)

    ld vy(ix), #2

    endCheckMovement:
    ld hl, #Key_Space
    call cpct_isKeyPressed_asm
    push af
    ld hl, #Joy0_Fire1
    call cpct_isKeyPressed_asm
    pop bc
    or b
    cp #0  
    jr z, endCheckKeyboard
    ;; IS PRESSED
    call man_game_player_shot

    endCheckKeyboard:
    ret