.include "defineValues.h.s"
.include "manager/manager.h.s"
.include "manager/game.h.s"
.include "cpctelera.h.s"
.include "cpct_includes.h.s"

;;;;;;;;;;;;;;;;;;;;
;; INPUT: IX -> Direccion de memoria de la entidad
;;;;;;;;;;;;;;;;;;;;
.globl FW_BRIGHT_BLUE
.globl _spr_portada_0
.globl _spr_portada_1
.globl _spr_press_space
.globl _spr_logo
.globl _spr_gameover
.globl _spr_gameoverInstructions
.globl SPR_LOGO_H
.globl SPR_LOGO_W
.globl SPR_LVL_H
.globl SPR_LVL_W
.globl SPR_PRESS_SPACE_W
.globl SPR_PRESS_SPACE_H
.globl SPR_GAMEOVER_W
.globl SPR_GAMEOVER_H
.globl SPR_GAMEOVERINSTRUCTIONS_W
.globl SPR_GAMEOVERINSTRUCTIONS_H
.globl SPR_FONDO_H
.globl SPR_FONDO_W
.globl SPR_HIERBA_H
.globl SPR_HIERBA_W
.globl SPR_CORAL_H
.globl SPR_CORAL_W
.globl _spr_fondo_0
.globl _spr_fondo_1
.globl _spr_hierba_0
.globl _spr_hierba_1
.globl SPR_PLAYERSHIP_H
.globl SPR_PLAYERSHIP_W
.globl _spr_shots_left
.globl m_shots_left
.globl _spr_vshot
.globl SPR_PLAYERSHOT_H
.globl SPR_PLAYERSHOT_W
.globl _spr_victory
.globl _spr_end_game_1
.globl _spr_end_game_0

string_lvl_one: 
    .db 'L', 'e', 'v', 'e', 'l', ' ', '1', 0

r_counter_drawSpace:
    .dw counter_parpadeo

r_counter_parpadeo:
    .dw counter_parpadeo

PORTADA_H = 150
PORTADA_W = 31
VICTORIA_H = 120
VICTORIA_W = 50
ENDGAME_H = 40
ENDGAME_W = 40

sys_render_one_entity::

    ; IF entity NOT dead -> drawSprite


    ld a, previous_screen+1(ix) ;; pilla el bit bajo
    or a
    jr z, dont_clean_previous  ;; jr z, dont_clean_previous

    clean_previous:
    ld d, a
    ld e, previous_screen(ix)
    ld b, height(ix)
    ld c, width(ix)
    ld a, #0x3C
    call cpct_drawSolidBox_asm
    ld a, (ix)                  ; a = entity-type
    and #TYPE_DEAD
    jr nz, finRender
    ;; ###########################################
    ;; DIBUJAR NUEVA POSICION
    dont_clean_previous:



    ld de, #CPCT_VMEM_START_ASM ; puntero al inicio de memoria de vid
    ld c, x(ix)                  ; c = entity->x
    ld b, y(ix)                  ; b = entity->y  
    call cpct_getScreenPtr_asm
    ld previous_screen(ix), l
    ld previous_screen+1(ix), h
    ex de, hl                    ; hl es output of cpct_getScreenPtr

    ld h, sprite+1(ix)
    ld l, sprite(ix)                                    
    ld c, width(ix) 
    ld b, height(ix)
    call cpct_drawSprite_asm

    
    finRender:
    ld a, x(ix)
    cp #8
    jr c, borderIni
    ld b, width(ix)

    add b
    add #1
    cp #76
    jr c, salirRender
    ld de, #0xC000
    ld c, #76
    ld a, y(ix)
    sub #2
    ld b, a
    call cpct_getScreenPtr_asm
    ex de, hl
    ;ld a, #0
    ld c, #4
    ld a, height(ix)
    add #4
    ld b, a
    ld a, #0
    call cpct_drawSolidBox_asm
    jr salirRender
    borderIni:
        ld de, #0xC000
        ld c, #0
        ld a, y(ix)
        sub #5
        ld b, a
        call cpct_getScreenPtr_asm
        ex de, hl
        ;ld a, #0
        ld c, #4
        ld a, height(ix)
        add #10
        ld b, a
        ld a, #0
        call cpct_drawSolidBox_asm
    salirRender:
    ret


sys_render_update::
    ld hl, #sys_render_one_entity
    ld b, #CMP_RENDER
    call man_update_forall_matching
    ret


sys_render_clear::
    ld de, #0xC000
    ld b, #200
    ld c, #64
    ld a, #0x3C
    call cpct_drawSolidBox_asm

    ld de, #0xC020
    ld b, #200
    ld c, #64
    ld a, #0x3C
     
    call cpct_drawSolidBox_asm
    ret

;; INPUT: HL - Texto Lvl
renderLoadingScreen::
    push hl

    ld de, #0xC000
    ld b, #200
    ld c, #64
    ld a, #0x00
    call cpct_drawSolidBox_asm

    ld de, #0xC020
    ld b, #200
    ld c, #64
    ld a, #0x00
    call cpct_drawSolidBox_asm

    ld de, #0xC000
    ld c, #30
    ld b, #10
    call cpct_getScreenPtr_asm
    ex de, hl
    pop hl                              
    ld c, #SPR_LVL_W
    ld b, #SPR_LVL_H
    call cpct_drawSprite_asm

    ld de, #0xC000
    ld c, #30
    ld b, #70
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_spr_logo                              
    ld c, #SPR_LOGO_W
    ld b, #SPR_LOGO_H
    call cpct_drawSprite_asm

    ;;(2B IY) string	Pointer to the null terminated string being drawn
    ;;(2B HL) video_memory	Video memory location where the string will be drawn
    ;;ld iy, #string_lvl_one

    ;;call cpct_drawStringM0_asm
    decrementaCounterLoading:

    ld iy, #r_loading_screen_counter
    call man_check_counter_zero_or_decrease

    cp #0
    jr z, finLoading
    jr decrementaCounterLoading
    finLoading:
    ld iy, #counter_loading
    ld (r_loading_screen_counter), iy
    ret


renderPortada::
    ld de, #0xC000
    ld b, #200
    ld c, #40
    ld a, #0x00
    call cpct_drawSolidBox_asm

    ld de, #0xC020
    ld b, #200
    ld c, #60
    ld a, #0x00
    call cpct_drawSolidBox_asm
    ld de, #0xC000
    ld c, #9
    ld b, #0
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_spr_portada_0                            
    ld c, #PORTADA_W
    ld b, #PORTADA_H
    call cpct_drawSprite_asm

    ld de, #0xC000
    ld c, #40
    ld b, #0
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_spr_portada_1                                
    ld c, #PORTADA_W
    ld b, #PORTADA_H
    call cpct_drawSprite_asm

   ; ld iy, #r_counter_drawSpace
   ; call man_check_counter_zero_or_decrease
;
   ; cp #0
   ; jr nz, pressSpace
   ; ld iy, #r_counter_parpadeo
   ; call man_check_counter_zero_or_decrease
;
   ; cp #0
   ; jr z, reloadSpaceCounter
;
;    pressSpace:
;    ld iy, #counter_parpadeo
;    ld (r_counter_parpadeo), iy
;
    ld de, #0xC000
    ld c, #18
    ld b, #150
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_spr_press_space                            
    ld c, #SPR_PRESS_SPACE_W
    ld b, #SPR_PRESS_SPACE_H
    call cpct_drawSprite_asm
;
    ret


renderDeathScreen::
    ld de, #0xC000
    ld b, #200
    ld c, #64
    ld a, #0x00
    call cpct_drawSolidBox_asm
    ld de, #0xC010
    ld b, #200
    ld c, #64
    ld a, #0x00
    call cpct_drawSolidBox_asm

    ld de, #0xC000
    ld c, #22
    ld b, #30
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_spr_gameover                             
    ld c, #SPR_GAMEOVER_W
    ld b, #SPR_GAMEOVER_H
    call cpct_drawSprite_asm

    ld de, #0xC000
    ld c, #17
    ld b, #130
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_spr_gameoverInstructions                             
    ld c, #SPR_GAMEOVERINSTRUCTIONS_W
    ld b, #SPR_GAMEOVERINSTRUCTIONS_H
    call cpct_drawSprite_asm

    decrementaCounterGameOver:

    ld iy, #r_loading_screen_counter
    call man_check_counter_zero_or_decrease

    cp #0
    jr z, finGameOver
    jr decrementaCounterGameOver
    finGameOver:
    ld iy, #counter_loading
    ld (r_loading_screen_counter), iy

    ret

renderFondo::
    ld de, #0xC000
    ld c, #0
    ld b, #168
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_spr_fondo_0                            
    ld c, #SPR_FONDO_W
    ld b, #SPR_FONDO_H
    call cpct_drawSprite_asm
    
    ld de, #0xC000
    ld c, #40
    ld b, #168
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_spr_fondo_1                            
    ld c, #SPR_FONDO_W
    ld b, #SPR_FONDO_H
    call cpct_drawSprite_asm

    ld de, #0xC000
    ld c, #0
    ld b, #171
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_spr_hierba_0                            
    ld c, #SPR_HIERBA_W
    ld b, #SPR_HIERBA_H
    call cpct_drawSprite_asm

    ld de, #0xC000
    ld c, #40
    ld b, #171
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_spr_hierba_1                            
    ld c, #SPR_HIERBA_W
    ld b, #SPR_HIERBA_H
    call cpct_drawSprite_asm
    
    ld de, #0xC000
    ld c, #4
    ld b, #2
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_spr_shots_left                            
    ld c, #16
    ld b, #12
    call cpct_drawSprite_asm

    ;; RENDER SHOTS LEFT

    ld de, #0xC000
    ld c, #shot_1_x
    ld b, #4
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_spr_vshot                         
    ld c, #SPR_PLAYERSHOT_W
    ld b, #SPR_PLAYERSHOT_H
    call cpct_drawSprite_asm

    ld de, #0xC000
    ld c, #shot_2_x
    ld b, #4
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_spr_vshot                         
    ld c, #SPR_PLAYERSHOT_W
    ld b, #SPR_PLAYERSHOT_H
    call cpct_drawSprite_asm

    ld de, #0xC000
    ld c, #shot_3_x
    ld b, #4
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_spr_vshot                         
    ld c, #SPR_PLAYERSHOT_W
    ld b, #SPR_PLAYERSHOT_H
    call cpct_drawSprite_asm

    ld de, #0xC000
    ld c, #shot_4_x
    ld b, #4
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_spr_vshot                         
    ld c, #SPR_PLAYERSHOT_W
    ld b, #SPR_PLAYERSHOT_H
    call cpct_drawSprite_asm

    ld de, #0xC000
    ld c, #shot_5_x
    ld b, #4
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_spr_vshot                         
    ld c, #SPR_PLAYERSHOT_W
    ld b, #SPR_PLAYERSHOT_H
    call cpct_drawSprite_asm

    ret

renderVictoria::

    call sys_render_clear
    ld de, #0xC000
    ld c, #30
    ld b, #80
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_spr_victory                         
    ld c, #VICTORIA_W
    ld b, #VICTORIA_H
    call cpct_drawSprite_asm

    ld de, #0xC000
    ld c, #0
    ld b, #20
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_spr_end_game_0                        
    ld c, #ENDGAME_W
    ld b, #ENDGAME_H
    call cpct_drawSprite_asm

    ld de, #0xC000
    ld c, #40
    ld b, #20
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_spr_end_game_1                      
    ld c, #ENDGAME_W
    ld b, #ENDGAME_H
    call cpct_drawSprite_asm

    ret

render_remove_shots_counter::

    ld a, (m_shots_left)
    cp #4
    jr z, removeFifth

    cp #3
    jr z, removeFourth

    cp #2
    jr z, removeThird

    cp #1
    jr z, removeSecond

    ;; removeFirst


    ld de, #0xC000
    ld c, #shot_1_x
    ld b, #4
    call cpct_getScreenPtr_asm
    jr removeCounter

    removeSecond:
    ld de, #0xC000
    ld c, #shot_2_x
    ld b, #4
    call cpct_getScreenPtr_asm
    jr removeCounter

    removeThird:
    ld de, #0xC000
    ld c, #shot_3_x
    ld b, #4
    call cpct_getScreenPtr_asm
    jr removeCounter

    removeFourth:
    ld de, #0xC000
    ld c, #shot_4_x
    ld b, #4
    call cpct_getScreenPtr_asm
    jr removeCounter

    removeFifth:
    ld de, #0xC000
    ld c, #shot_5_x
    ld b, #4
    call cpct_getScreenPtr_asm
    jr removeCounter

    removeCounter:
    ex de, hl
    ld b, #SPR_PLAYERSHOT_H
    ld c, #SPR_PLAYERSHOT_W
    ld a, #0x3C
    call cpct_drawSolidBox_asm                         

    ret



render_add_shots_counter::
    ld a, (m_shots_left)
    cp #5
    jr z, addFifth

    cp #4
    jr z, addFourth

    cp #3
    jr z, addThird

    cp #2
    jr z, addSecond

    ;; addFirst
    ld de, #0xC000
    ld c, #shot_1_x
    ld b, #4
    call cpct_getScreenPtr_asm
    jr drawCounter

    addSecond:
    ld de, #0xC000
    ld c, #shot_2_x
    ld b, #4
    call cpct_getScreenPtr_asm
    jr drawCounter

    addThird:
    ld de, #0xC000
    ld c, #shot_3_x
    ld b, #4
    call cpct_getScreenPtr_asm
    jr drawCounter

    addFourth:
    ld de, #0xC000
    ld c, #shot_4_x
    ld b, #4
    call cpct_getScreenPtr_asm
    jr drawCounter

    addFifth:
    ld de, #0xC000
    ld c, #shot_5_x
    ld b, #4
    call cpct_getScreenPtr_asm
    jr drawCounter

    drawCounter:
    ex de, hl
    ld hl, #_spr_vshot                            
    ld c, #SPR_PLAYERSHOT_W
    ld b, #SPR_PLAYERSHOT_H
    call cpct_drawSprite_asm

    ret
